#include <stdio.h>
#include "global.h"
#include "1tr6tables.h"


void prsrvind (u_char *buf) {
  unsigned char ai;
  printf("%s\n", find(ServiceIndicator, (buf[2]&0x7F)<<8));
  ai=buf[3];
  if (((buf[2]&0x80)==0) & (ai>0)) {
    printf("				  ");
    if (buf[2]==0x03) {
	     if (ai==0)	printf("\r");
	else if (ai<0x40)	printf("%.2X (Reserviert DBP Telekom)\n", ai);
	else if (ai<0x80)	printf("%.2X (Reserviert ZVEI)\n", ai);
	else if (ai<0xA0)	printf("%.2X (Private Anwendungen)\n", ai);
	else if ((ai&0xE0)==0xA0) {
				printf("  Synchrone Bitratenadaption\n");
		if (ai&0x10)	printf("  V.120\n");
		else		printf("  V.110 / X.30 (ECMA 102)\n");
		switch (ai&0x0F) {
			case 0x00:	printf("1200 bit/s\n");
			case 0x01:	printf("1200/75 bit/s\n");
			case 0x02:	printf("75/1200 bit/s\n");
			case 0x03:	printf("2400 bit/s\n");
			case 0x04:	printf("4800 bit/s\n");
			case 0x05:	printf("9600 bit/s\n");
			case 0x06:	printf("14400 bit/s V.32 bis\n");
			case 0x07:	printf("19200 bit/s\n");
			case 0x08:	printf("49000 bit/s\n");
			case 0x09:	printf("56000 bit/s\n");
			case 0x0F:	printf("in-band negotiation\n");
			default:	printf("Undefined (%.2X)\n",ai&0x0F);
		}
	} else {
				printf("  Asynchrone Bitratenadaption\n");
				printf("  Number of data bits: %d\n",ai&0x20?7:8);
				printf("  Number of stop bits: %d\n",ai&0x20?2:1);
				printf("  Parity: %s\n",ai&0x08?"even":"no");
		switch (ai&0x07) {
			case 0x00:	printf("1200 bit/s\n");
			case 0x01:	printf("1200/75 bit/s\n");
			case 0x02:	printf("75/1200 bit/s\n");
			case 0x03:	printf("2400 bit/s\n");
			case 0x04:	printf("4800 bit/s\n");
			case 0x05:	printf("9600 bit/s\n");
			case 0x06:	printf("14400 bit/s\n");
			case 0x07:	printf("19200 bit/s\n");
		}
	}
    } else {
      printf("%s\n", find(ServiceIndicator, buf[2]<<8|buf[3]));
    }
  }
}

void dlog1tr6(u_char * buf, u_char * bend, int size) {
  u_char pd, cr_l, mt;
  int cset = 0, cs_old = 0, cs_fest = 0;
  unsigned int cr;

  pd = *buf++;
  cr_l = *buf++;
  if (cr_l)
    cr = *buf++;
  else
    cr = 0;
  mt = *buf++;
  printf("\n  %s\n", find(mt1tr6, pd<<8|mt));

  while (buf < bend) {
    if (*buf & 0x80) {	/* Is it a single octet information element? */
      switch (*buf & 0x70) {
	case 0x10:	printf("  Shift %.2X\n", *buf & 0x0F);
	  cs_old = cset;
	  cset = *buf & 0x07;
	  cs_fest = *buf & 0x08;
	  break;
	case 0x20:
	  switch (*buf & 0x0f) {
	    case 0:	printf("  More data\n");	break;
	    case 1:	printf("  Sending complete\n");	break;
	    default:	printf("  unknown single octett W-Element Set %.2X Code %.2X\n",cset, *buf);
          }
          break;
        case 0x30:	printf("  Congestion level %.2X\n", *buf & 0x0F);
          break;
	default:	printf("  unknown single octett W-Element Set %.2X Code %.2X\n",cset, *buf);
      }
      buf++;
      continue;
    } else {
      printf("  ");
      sprintf(indent,"    ");
      switch(cset<<8|*buf) {
/**/	case 0x004:	printf("Bearer Service Identificatio\n");	general(buf);		break;
	case 0x008:	printf("Cause\t\t\t%.2X	%s\n", buf[2]&0x7F, find(cause_1tr6,buf[2]&0x7F));	break;
	case 0x00C:	printf("Connected Address\n");			prnumber(buf,0,0);	break;
	case 0x010:	printf("Call IDentity			%d\n", buf[2]&0x0F);		break;
/**/	case 0x014:	printf("Call State\n");				general(buf);		break;
	case 0x018:	printf("Channel IDentitification\n");		prchannel(buf);		break;
/**/	case 0x01C:	printf("CCITT-Standard Facilities\n");		general(buf);		break;

	case 0x020:	printf("Network Specific Facility\n");		general(buf);		break;
/**/	case 0x024:	printf("Terminal Capabilities\n");		general(buf);		break;
	case 0x028:	printf("Display\n");				prdisplay(buf);		break;
	case 0x02C:	printf("Keypad\n");				general(buf);		break;
/**/	case 0x030:	printf("Keypad Echo\n");			general(buf);		break;
/**/	case 0x034:	printf("Signal\n");				general(buf);		break;
/**/	case 0x036:	printf("Switchhook\n");				general(buf);		break;

	case 0x06C:	printf("Origination Address\n");		prnumber(buf,0,0);	break;
	case 0x070:	printf("Destination Address\n");		prnumber(buf,0,0);	break;
/**/	case 0x074:	printf("Redirecting Address\n");		prnumber(buf,1,0);	break;
/**/	case 0x078:	printf("Transmit Network Selection\n");		general(buf);		break;
/**/	case 0x07C:	printf("Compatibility\n");			general(buf);		break;
	case 0x07E:	printf("User-User Information\n");		general(buf);		break;

	case 0x601:	printf("Service Indicator		");	prsrvind(buf);		break;
	case 0x602:	printf("Charging Information\n");		general(buf);		break;
	case 0x603:	printf("Date\n");				prdisplay(buf);		break;
	case 0x605:	printf("Facility Select\n");			general(buf);		break;
	case 0x606:	printf("Status of Facilities\n");		general(buf);		break;
	case 0x607:	printf("Status des gerufenen Tln\n");		general(buf);		break;
	case 0x608:	printf("Additional Transmission Attributes\n");	general(buf);		break;
	default:	printf("unknown W-Element Set %.2X Code %.2X length %d\n\t\t\t\t",cset, *buf, buf[1]);
			for(mt=0; mt<buf[1]; mt++) {
				printf(" %.2X", buf[mt+2]);
			}
			printf("\n");
      }
    }
    /* Skip to next element */
    buf += buf[1] + 2;

    if (cs_fest) {
      cset = cs_old;
      cs_old = 0;
      cs_fest = 0;
    }
  }
}
