#include <stdio.h>
#include "global.h"

void dlogAckermann(u_char * buf, u_char * bend, int size) {
  u_char p;

  printf("\nEuracom status\n");
  buf+=5;
  bend--;
  switch (*buf) {
    case 0x01:
      printf("  Active ports:			%.2X %.2X %.2X",
      buf[2], buf[3], buf[4]);
      if (buf[5] || buf[6]) {
	printf("\n    S0 ports			");
	for(p=0;p<7;p++) {
	  if ((buf[5]|buf[6])&(1<<p)) {
	    printf("P%d(",p+1);
	    if (buf[5]&(1<<p)) printf("1");
	    if (buf[6]&(1<<p)) printf("2");
	    printf(") ");
	  }
	}
      }
      buf+=6;
      if (bend[0]==0 || bend[0]==0xFF) bend--;
      if (buf<bend) {
	printf("\n    extension			");
	while (buf++ < bend)
	  printf("%.2X ",*buf);
      }
      break;
    case 0x02:
      printf("  Date/Time			%.2d.%.2d.%.2d %.2d:%.2d",
      buf[4], buf[3], buf[2], buf[5], buf[6]);
      break;
    case 0x20:
      printf("  P4 Display 1			%.2X %.2X %.2X %.2X   "
      "%.2X %.2X %.2X %.2X\n				\"",
      buf[4], buf[3], buf[2], buf[5], buf[6], buf[7], buf[8], buf[9]);
      buf+=8;
      while (buf<=bend) printf("%c",*buf++);
      printf("\"");
      break;
    case 0x21:
      printf("  P4 Display 2			%.2X", *buf);
      for(p=1;p<11;p++) {
        printf(" %.2X", buf[p]);
        if (p==2 || p==6) printf("  ");
      }
      buf+=11;
      printf("\n				\"");
      while (buf<=bend) printf("%c",*buf++);
      printf("\"");
      break;
    case 0x2B:
      printf("  Caller ID			%.2X  --  "
      "%.2X %.2X %.2X %.2X %.2X\n				\"",
      buf[1], bend[-4], bend[-3], bend[-2], bend[-1], bend[0]);
      buf+=2;
      bend-=4;
      while (buf<=bend) printf("%c",*buf++);
      printf("\"");
      break;
    case 0x83:
      printf("  Restart			%.2X %.2X %.2X",
      buf[2], buf[3], buf[4]);
      break;
    default:
      printf("  ???			%.2X	",*buf);
      while (buf++ < bend)
	printf("%.2X ",*buf);
  }
  printf("\n");
}
