/* all stuff about facilities */


/*

 0,"all services"
 1,"Speech"
 2,"UDI"
 3,"Audio 3.1kHz"
 4,"UDI with tones/announcements"
 5,"Multirate"
32,"Telephony 3.1kHz"
33,"Teletex"
34,"Telefax Group 4 Class 1"
35,"Videotex syntax based"
36,"Videotelephony"
37,"Telefax Group 2-3"
38,"Telephony 7kHz"
39,"Euro file transfer"
40,"File transfer and access management"
41,"Video conference"
42,"Audio Graphic conference"


Sequence tag 30
Set tag	     31


 2,"Invoke identifier"
 5,"Null"
80,"Linked identifier"


 2,"Integer"
 6,"Object identifier"

*/
/*

80,"General problem"
81,"Invoke problem"
82,"Return result problem"
83,"Return result problem"

;general problem
 0,"Unrecognized component"
 1,"Mistyped component"
 2,"Badly structured component"

;invoke problem
 0,"Duplicate invocation"
 1,"Unrecognized operation"
 2,"Mistyped argyment"
 3,"Resource limitation"
 4,"Initiator releasing"
 5,"Ungecognized linked identifier"
 6,"Linked response unexpected"
 7,"Unexpected child operation"

;return result problem
 0,"Unrecognized invocation"
 1,"Result response unexpected"
 2,"Mistyped result"

;return error problem
 0,"Unrecognized invocation"
 1,"Error response unexpected"
 2,"Unrecognized error"
 3,"Unexpected error"
 4,"Mistyped parameter"


 1,"Status request operation"
 2,"General errors"
 3,"Facility information element component"
 4,"Explicit network controlled channel reservation"
 5,"Notification data structure"
 6,"Addressing data elements"
 7,"Embedded Q.931 types"
 8,"Basic service elements"
 9,"Status request procedure"

*/
/*

 0,"AOC-S"
 1,"AOC-D"
 2,"AOC-E"

 1,"Duration currency"
 2,"Flat rate currency"
 3,"Volume rate currency"
 4,"Free of charge"
 5,"Currency info not available"

 0,"Basic communication"
 1,"Call attempt"
 2,"Call setup"
 3,"User to user info"
 4,"Operation of supplementary Services"

 1,"Currency"
 2,"Amount"
 3,"Charging type"
 4,"Time"
 5,"Granularity"

 1,"Currency"
 2,"Amount"
 3,"Volume Unit" ()

 1,"Recorded Currency"
 2,"Type of charging info"
 3,"AOCD billing ID"

 1,"Recorded units list"
 2,"Type of charging info"
 3,"AOCD billing ID"

 1,"Sub total"
 2,"total"

 0,"Normal charging"
 1,"Reverse charging"
 2,"Credit card charging"
 3,"CF U"
 4,"CF B"
 5,"CF NR
 6,"CD"
 7,"CT"

 ;multiplier
 0,0.001
 1,0.01
 2,0.1
 3,1
 4,10
 5,100
 6,1000

 ;scale
 0,0.01s
 1,0.1s
 2,1s
 3,10s
 4,1m
 5,1h
 6,1d

 ;volume unit
 0,octet
 1,segment
 2,message

 ;charging type
 0,"Continous charging"
 1,"Step function"
*/


struct vtsl F_int[] = {
	{0x01, "UUs"},
	{0x02, "CUG Call"},
	{0x03, "MCID Request"},
	{0x04, "Begin 3PTY"},
	{0x05, "End 3PTY"},
	{0x06, "ECT Request"},
	{0x07, "Activation Diversion"},
	{0x08, "Deactivation Diversion"},
	{0x09, "Activation Status Notification Diversion"},
	{0x0a, "Deactivation Status Notification Diversion"},
	{0x0b, "Interrogation Diversion"},
	{0x0c, "Diversion Information"},
/*	{0x0c, "Invalid Diverted To Number"},	*/
	{0x0d, "Call Deflection"},
	{0x0e, "Call Rerouting"},
/*	{0x0e, "Special Service Number"},	*/
	{0x0f, "Diverting LegInformation 2"},
/*	{0x0f, "Diversion To Served User Number"},	*/

	{0x10, "Invoke Status"},
	{0x11, "Interrogation Diversion 1"},
/*	{0x11, Iterrogation Served User Numbers"}	*/
	{0x12, "Diverting Leg Information 1"},
	{0x13, "Diverting Leg Information 3"},
	{0x14, "Explicit Reservation Creation Control"},
	{0x15, "Explicit Reservation Management"},
	{0x16, "Explicit Reservation Cancel"},
/*	{0x17, "incomming Call Accepted"},	*/
	{0x18, "MLPP lfb Query"},
/*	{0x18, "Number Of Diversions Exceeded"},	*/
	{0x19, "MLPP Call Request"},
	{0x1a, "MLPP Call preemption"},
	/* 1a  "No charging info available"*/
	{0x1e, "Charging Request"},
	{0x1f, "AOCS currncy"},

	{0x20, "AOCS special arrangement"},
	{0x21, "AOCD currency"},
	{0x22, "AOCD charging unit"},
	{0x23, "AOCE currency"},
	{0x24, "AOCE charging unit"},
	{0x25, "Identification of Charge"},

	{0x28, "Begin Conf"},
	{0x29, "Add Conf"},
	{0x2a, "Split Conf"},
	{0x2b, "Drop Conf"},
	{0x2c, "Isolate Conf"},
	{0x2d, "Reattach Conf"},
	{0x2e, "Party DISC"},
/*	{0x2e, "Not Activated"},	*/
	{0x2f, "Float Conf"},
	{0x30, "End Conf"},
/*	{0x30, "Request Already Accepted"},	*/
	{0x31, "Identify Conferee"},

	{0x3c, "Request REV"},
	{  -1, ""} };


char *cer_uclass[] = {
	/* 00 P  */ "End of Content",
	/* 01 P  */ "Boolean",
	/* 02 P  */ "Integer",
	/* 03 PC */ "Bit String",
	/* 04 PC */ "Octet String",
	/* 05 P  */ "Null",
	/* 06 P  */ "Object Identifier",
	/* 07 PC */ "Object Descriptor",
	/* 08  C */ "External",
	/* 09 P  */ "Real (float)",
	/* 0a P  */ "Enumerated",
	/* 0b  C */ "Embedded PDV",
	/* 0c PC */ "UTF8String",
	/* 0d P  */ "Relative-OID",
	/* 0e    */ "(reserved) 0x0e",
	/* 0f    */ "(reserved) 0x0f",

	/* 10  C */ "Sequence",
	/* 11  C */ "Set",
	/* 12 PC */ "NumericString",
	/* 13 PC */ "PrintableString",
	/* 14 PC */ "T61String",
	/* 15 PC */ "VideotexString",
	/* 16 PC */ "IA5String",
	/* 17 PC */ "UTCTime",
	/* 18 PC */ "GeneralizedTime",
	/* 19 PC */ "GraphicString",
	/* 1a PC */ "VisibleString",
	/* 1b PC */ "GeneralString",
	/* 1c PC */ "UniversalString",
	/* 1d PC */ "CharacterString",
	/* 1e PC */ "BMPString",
	/* 1f    */ "(use long form)"
};



void prfacRejC(u_char *p, int l) {
  int l2, t;

  printf("Reject component\n");

  l2 = (*p++ & 0x7f)-1;
  t = *p++;
  l -= 3;
  printf("      Class			%s\n",facclass[t>>6]);
  printf("      Form			");
  if (t&0x20)	printf("Constructor\n");
  else		printf("Primitive\n");
  switch (t) {
    case   2:printf("    Invoke identifier tag	");	break;
    case   5:printf("    Null			");	break;
    case 128:printf("    Linked identifier tag	");	break;
    default :printf("    Unknown ident. tag (%.2X)	",t);
  }
  t=*p++;
  l2--;
  l--;
  while(t--) {
    printf("%.2X",*p++);
    l--;
    l2--;
  }
  printf("\n");
  while (l2--) {
    switch (*p) {
      case 2 :printf("    Integer			");	break;
      case 6 :printf("    Object			");	break;
      default:printf("    Unknown (%.2X)		",*p);
    }
    p++;
    t=*p++;
    l2--;
    l-=2;
    while (t--) {
      printf("%.2X ", *p++);
      l--;
      l2--;
    }
    printf("\n");
  }
}


void prFacSequence(u_char *p, int l, int i) {
  int major,t,l2,c;

  major=*(p-2);
  while (l>0) {
    t=*p++;
    if (major==6 && (t & 0x80)) {t=((t&0x7F)<<7)|(*p++ &0x7F);l--;}
    l2=*p++;
    if (l2 & 0x80) {l2=((l2&0x7F)<<7)|(*p++ &0x7F);l--;}
    l-=l2+2;
    for(c=i+2;c>0;c--) printf("  ");
    printf("Tag %.2X		",t);
    if (i<3) printf("	");
    for(c=i;c>0;c--) printf(">");
    printf(" ");
    if (major==0x3011 && t==0x0A) {
      printf("Redirection type:	%s\n", find(redirtyp,*p++));
      l2--;
      while (l2--) {
        printf("%.2X ", *p++);
      }
    } else
    if (major==0xA1 && t==0x0A) {
      printf("Type of number:	%s\n", numtyp[*p++]);
      t=--l2;
      while (l2--) printf("%.2X ", *p++);
      if (t) printf("\n");
    } else
    if (major==0xA1 && t==0x12) {
      printf("Number:	\"");
      while (l2--) printf("%c", *p++);
      printf("\"\n");
    } else
    if (major==0x30 && t==0x80) {
      printf("Number:	\"");
      while (l2--) printf("%c", *p++);
      printf("\"\n");
    } else
    if (t==0x06 || t==0x30 || t==0x31 || t==0x40 || t==0xA1) {
      printf("Sequence:\n");
      prFacSequence(p,l2,i+1);
      p+=l2;
    } else
    {
      if (l2==0) printf("<empty>");
      while (l2--) printf("%.2X ", *p++);
      printf("\n");
    }
  }
}


void prfacility(u_char *p,int l) {
  int l2,l3,t;

  t=(*p++) & 0x1F;
  printf("    Protocol profile		");
  if (t==0x11) {
    printf("Remote Operations Protocol\n");
    while (l>0) {
      t=*p++;
      l2 = *p++;
      if (l2 & 0x80) {l2=((l2&0x7F)<<7)|(*p++ &0x7F);l--;}
      l2--;
      l-=l2+3;
      printf("    Class			%s\n",facclass[t>>6]);
      printf("    Form			");
      if (t&0x20)	printf("Constructor\n");
      else		printf("Primitive\n");
      printf("    Component tag		");
      switch (t&0x1f) {
	case  1:printf("Invoke\n");		break;
	case  2:printf("Return result\n");	break;
	case  3:printf("Return error\n");	break;
	case  4:printf("Reject component\n");	break;
	case 15:printf("Extension\n");		break; /* !!! */
	default:printf("??? (%.2X)\n",t&0x1f);
      }
      p++;
      l3=*p++;
      l2-=l3+2;
      t=0;
      while (l3--)
        t=(t<<8)|*p++;
      printf("    Request ID			%X\n",t);

      if (*p==2) {
      p++;
      l3=*p++;
      l2-=l3+2;
      t=0;
      while (l3--)
        t=(t<<8)|*p++;
      printf("    Operation type		%s\n",find(F_int,t));
      }
      prFacSequence(p,l2,0);
    }
  } else {
    if	    (t==0x12)	printf("CMIP Protocol (Q.941)");
    else if (t==0x13)	printf("ACSE Protocol (X.217, X.227)");
    else if (t==0x1F)	printf("ISO Networking extensions");
    else		printf("??? (%.2X)",t);
    t=8;
    while (l--) {
      if (t>7) {
        t=0;
        printf("\n				");
      }
      t++;
      printf("%.2X ", *p++);
    }
    printf("\n");
  }
}


void prSfacility(u_char *p) {
  int l;

  p++;
  l = (*p++)-1;
  prfacility(p, l);
}


void prEfacility(u_char *p) {
  int l=0;

  p++;
  while ((*p & 0x80)==0)
    l = (l<<7) | ((*p++)&0x7F);
  l = (l<<7) | *p++;
  prfacility(p, l);
}
