/*
	Tables for Q.931 decoding
*/
/*		123456789012345678901234567890123456789012345678 */

#ifndef dss1tables
#define dss1tables

#include "global.h"


struct vtsl cvlist[] = {
	/* 0x   normal event */
	{0x01, "Unallocated (unassigned) number"},
	{0x02, "No route to specified transit network"},
	{0x03, "No route to destination"},
	{0x04, "Send special information tone"},
	{0x05, "Misdialled trunk prefix"},
	{0x06, "Channel unacceptable"},
	{0x07, "Call awarded and being delivered in an\n\
				established channel"},
	{0x08, "Preemption"},
	{0x09, "Preemption - circuit reserved for reuse"},
	{0x0B, "More digits received than allowed,\n\
				call is proceeding"},
	{0x0E, "QoR: Ported number"},

	/* 1x   normal event */
	{0x10, "Normal call clearing"},
	{0x11, "User busy"},
	{0x12, "No user responding"},
	{0x13, "No answer from user (user alerted)"},
	{0x14, "Subscriber absent"},
	{0x15, "Call rejected"},
	{0x16, "Number changed"},
	{0x17, "Redirection to new destination"},
	{0x18, "Feature at the destination"},
	{0x19, "Exchange routing error"},
	{0x1A, "Non-selected user clearing"},
	{0x1B, "Destination out of order"},
	{0x1C, "Invalid number format (address incomplete)"},
	{0x1D, "Facility rejected"},
	{0x1E, "Response to Status enquiry"},
	{0x1F, "Normal, unspecified"},

	/* 2x   resource unavailable */
	{0x20, "[Service not supported]"},
	{0x21, "[Circuit out of order]"},
	{0x22, "No circuit/channel available"},
	{0x23, "[Call queued]"},
	{0x24, "[Out of order]"},
	{0x25, "[Degraded Service]"},
	{0x26, "Network out of order"},
	{0x27, "Permanent frame mode connection out of service"},
/*	{0x27, "[Transit delay range cannot be achieved]"}, */
	{0x28, "Permanent frame mode connection operational"},
/*	{0x28, "[Throughput range cannot be achieved]"}, */
	{0x29, "Temporary failure"},
	{0x2A, "Switching equipment congestion"},
	{0x2B, "Access information discarded"},
	{0x2C, "Requested circuit/channel not available"},
	{0x2D, "[Preempted]"},
	{0x2E, "Precedence call blocked"},
	{0x2F, "Resource unavailable, unspecified"},

	/* 3x   service or option not available */
	{0x31, "Quality of service unavailable"},
	{0x32, "Requested facility not subscribed"},
	{0x33, "[Reverse charging not allowed]"},
	{0x34, "[Outgoing calls barred]"},
	{0x35, "Outgoing calls barred within CUG"},
	{0x36, "[Incoming calls barred]"},
	{0x37, "Incoming calls barred within CUG"},
	{0x38, "[Call waiting not subscribed]"},
	{0x39, "Bearer capability not authorized"},
	{0x3A, "Bearer capability not presently available"},
	{0x3E, "Inconsistency in designated outgoing access\n\
				information and subscriber class"},
	{0x3F, "Service or option not available, unspecified"},

	/* 4x   service or option not implemented */
	{0x41, "Bearer capability not implemented"},
	{0x42, "Channel type not implemented"},
	{0x43, "[Transit network selection not impemented]"},
	{0x44, "[Message not implemented]"},
	{0x45, "Requested facility not implemented"},
	{0x46, "Only restricted digital information bearer\n\
				capability is available"},
	{0x4F, "Service or option not implemented, unspecified"},

	/* 5x   invalid message */
	{0x51, "Invalid call reference value"},
	{0x52, "Identified channel does not exist"},
	{0x53, "A suspended call exists, but this\n\
				call identity does not"},
	{0x54, "Call identity in use"},
	{0x55, "No call suspended"},
	{0x56, "Call having the requested call\n\
				identity has been cleared"},
	{0x57, "User not member of CUG"},
	{0x58, "Incompatible destination"},
	{0x59, "[Non-existant abbreviated address entry]"},
	{0x5A, "Non-existent CUG"},
	{0x5B, "Invalid transit network selection"},
	{0x5C, "[Invalid facility parameter 93 Mandatory\n\
				infomation element missing]"},
	{0x5D, "[Message type non-existent or not implemented]"},
	{0x5F, "Invalid message, unspecified"},

	/* 6x   protocol error */
	{0x60, "Mandatory information element is missing"},
	{0x61, "Message type non-existent or not implemented"},
	{0x62, "Message not compatible with call state or\n\
				message type non-existent or not implemented "},
	{0x63, "Information element/parameter non-existent or\n\
				not implemented"},
	{0x64, "Invalid information element contents"},
	{0x65, "Message not compatible with call state"},
	{0x66, "Recovery on timer expiry"},
	{0x67, "Parameter non-existent or not implemented -\n\
				passed on"},
	{0x6E, "Message with unrecognized parameter discarded"},
	{0x6F, "Protocol error, unspecified"},

	/* x    interworking */
	{0x7F, "Interworking, unspecified"},
	{  -1, ""} };


/* 1: 0x78 Transit network selection
   3: 7-5: Type of network identification
	   000 User specified
	   010 National
	   011 International
      4-1: Network Identification plan
	   0000 Unknown
	   0001 Carrier identification code
	   0011 Data network identification code (X.121)
   4+  IA5 chars

*/

struct vtsl uutype[] = {
	{0x00, "user specific protocol"},
	{0x01, "OSI high layer protocol"},
	{0x02, "Recommendation X.244 (X.25 structure)"},
	{0x03, "Reserved for system management convergence function"},
	{0x04, "IA5 characters"},
	{0x05, "X.208 / X.209 coded user information"},
	{0x07, "V.120 rate adaption"},
	{0x08, "Q.931/I.451 user-network call control messages"},
	{  -1, ""} };


struct vtsl mtlist[] = {
	{0x01, "ALERTING"},
	{0x02, "CALL PROCEEDING"},
	{0x03, "PROGRESS"},
	{0x05, "SETUP"},
	{0x07, "CONNECT"},
	{0x0D, "SETUP ACKNOWLEDGE"},
	{0x0F, "CONNECT ACKNOWLEDGE"},

	{0x20, "USER INFORMATION"},
	{0x21, "SUSPEND REJECT"},
	{0x22, "RESUME REJECT"},
	{0x23, "MODIFY REJECT"},
	{0x24, "HOLD"},
	{0x25, "SUSPEND"},
	{0x26, "RESUME"},
	{0x27, "MODIFY"},
	{0x28, "HOLD ACKNOWLEDGE"},
	{0x2D, "SUSPEND ACKNOWLEDGE"},
	{0x2E, "RESUME ACKNOWLEDGE"},
	{0x2F, "MODIFY COMPLETE"},

	{0x30, "HOLD REJECT"},
	{0x31, "RETRIEVE"},
	{0x33, "RETRIEVE ACKNOWLEDGE"},
	{0x37, "RETRIEVE REJECT"},

	{0x40, "DETACH"},
	{0x45, "DISCONNECT"},
	{0x46, "RESTART"},
	{0x48, "DETACH ACKNOWLEDGE"},
	{0x4D, "RELEASE"},
	{0x4E, "RESTART ACKNOWLEDGE"},

	{0x5A, "RELEASE COMPLETE"},

	{0x60, "SEGMENT"},
	{0x62, "FACILITY"},
	{0x64, "REGISTER"},
	{0x68, "CANCEL ACKNOWLEDGE"},
	{0x6A, "FACILITY ACKNOWLEDGE"},
	{0x6C, "REGISTER ACKNOWLEDGE"},
	{0x6E, "NOTIFY"},

	{0x70, "CANCEL REJECT"},
	{0x72, "FACILITY REJECT"},
	{0x74, "REGISTER REJECT"},
	{0x75, "STATUS ENQUIRY"},
	{0x79, "CONGESTION CONTROL"},
	{0x7B, "INFORMATION"},
	{0x7D, "STATUS"},
	{  -1, ""} };
#define MTSIZE sizeof(mtlist)/sizeof(struct vtsl)


char *causloc[] = {
	"User",
	"Local private network",
	"Local public network",
	"Transit network",
	"Remote public network",
	"Remote private network",
	"??? (06)",
	"International network",

	"??? (08)",
	"??? (09)",
	"Network beyond interworking point",
	"??? (0B)",
	"??? (0C)",
	"??? (0D)",
	"??? (0E)",
	"??? (0F)",
};


struct vtsl causrec[] = {
	{0x00, "Q.931"},
	{0x03, "X.21"},
	{0x04, "X.25"},
	{0x05, "PLMN, Q.1031 / Q.1051"},
	{  -1, ""} };


struct vtsl rejrea[] = {
	{0x00, "User specific"},
	{0x01, "Information element missing"},
	{0x02, "Information element contents are not sufficient"},
	{  -1, ""} };


char *condition[] = {
	"unknown",
	"permanent",
	"transient",
	"<spare> (03)"
};


struct vtsl attrnum[] = {
	{0x31, "Information transfer capability"},
	{0x32, "Information transfer mode"},
	{0x33, "Information transfer rate"},
	{0x34, "Structure"},
	{0x35, "Configuration"},
	{0x36, "Establishment"},
	{0x37, "Symmetry"},
	{0x38, "Information transfer rate (dest -> orig)"},
	{0x39, "layer identification"},
	{0x3A, "Rate multiplier"},
	{  -1, ""} };


struct vtsl bclist[] = {
	{0x00, "Speech"},
	{0x08, "Unrestricted digital information"},
	{0x09, "Restricted digital information"},
	{0x10, "3.1 kHz audio"},
	{0x11, "UDI with tones/announcemnts (7kHz audio)"},
	{0x18, "Video"},
	{  -1, ""} };


char *trmode[] = {
	"Circuit mode",
	"??? (01)",
	"Packet mode",
	"??? (03)"
};


struct vtsl trrate[] = {
	{0x00, "(packet switched)"},
	{0x10, "64 kbps"},
	{0x11, "2*64 kbps"},
	{0x13, "384 kbps"},
	{0x15, "1536 kbps"},
	{0x17, "1920 kbps"},
	{0x1C, "Multirate"},
	{  -1, ""} };


struct vtsl LLC5[] = {
	{0x01, "V.110/X.30 rate adaption"},
	{0x02, "G.711 -law"},
	{0x03, "G.711 A-law"},
	{0x04, "G.721 32 kbit/s ADPCM (I.460)"},
	{0x05, "G.722/G.725 7kHz audio H.221/H.242"},
	{0x06, "H.223/H.245"},
	{0x07, "Non-CCITT standardized rate adaption"},
	{0x08, "V.120 rate adaption"},
	{0x09, "X.31 rate adaption, HDLC flag stuffing"},
	{0x0A, "G.728 LD-CELP"},
	{0x0B, "G.729 CS-ACELP"},
	{  -1, ""} };


struct vtsl LLC5a[] = {
	{0x00, "indicated by E-bits (I.460) or\n\
				negotiated in-band"},
	{0x01, "600 bit/s, V.6 / X.1"},
	{0x02, "1200 bit/s, V.6"},
	{0x03, "2400 bit/s, V.6 / X.1"},
	{0x04, "3600 bit/s, V.6"},
	{0x05, "4800 bit/s, V.6 / X.1"},
	{0x06, "7200 bit/s, V.6"},
	{0x07, "8 kbit/s, I.460"},
	{0x08, "9600 bit/s, V.6 / X.1"},
	{0x09, "14400 bit/s, V.6"},
	{0x0a, "16 kbit/s, I.460"},
	{0x0b, "19200 bit/s, V.6"},
	{0x0c, "32 kbit/s, I.460"},
	{0x0d, "38,4 kbit/s, V.110"},
	{0x0e, "48 kbit/s, V.6 / X.1"},
	{0x0f, "56 kbit/s, V.6"},

	{0x12, "57.6 kbit/s, V.14"},
	{0x13, "28.8 kbit/s, V.110"},
	{0x14, "24 kbit/s, V.110"},
	{0x15, "134.5 bit/s, X.1"},
	{0x16, "100 bit/s, X.1"},
	{0x17, "75/1200 bit/s, V.6 / X.1"},
	{0x18, "1200/75 bit/s, V.6 / X.1"},
	{0x19, "50 bit/s, V.6 / X.1"},
	{0x1A, "75 bit/s, V.6 / X.1"},
	{0x1B, "110 bit/s, V.6 / X.1"},
	{0x1C, "150 bit/s, V.6 / X.1"},
	{0x1D, "200 bit/s, V.6 / X.1"},
	{0x1E, "300 bit/s, V.6 / X.1"},
	{0x1F, "12000 bit/s, V.6"},
	{  -1, ""} };


struct vtsl LLC5d[] = {
	{0x11, "V.21"},
	{0x12, "V.22"},
	{0x13, "V.22 bis"},
	{0x14, "V.23"},
	{0x15, "V.26"},
	{0x16, "V.26 bis"},
	{0x17, "V.26 ter"},
	{0x18, "V.27"},
	{0x19, "V.27 bis"},
	{0x1A, "V.27 ter"},
	{0x1B, "V.29"},
	{0x1C, "V.32"},
	{0x1D, "V.34"},
	{  -1, ""} };


struct vtsl LLC6[] = {
	{0x01, "Basic mode ISO 1745"},
	{0x02, "Recommendation Q.921 (I.441)"},
	{0x06, "Recommendation X.25"},
	{0x07, "Recommendation X.25 Multilink"},
	{0x08, "Extended LAPB; for half duplex operation (T.71)"},
	{0x07, "X.25 Multilink"},
	{0x09, "HDLC ARM (ISO 4335)"},
	{0x0A, "HDLC NRM (ISO 4335)"},
	{0x0B, "HDLC ABM (ISO 4335)"},
	{0x0C, "LAN logical link control (ISO 8802/2)"},
	{0x0D, "Recommendation X.75, Single Link Procedure (SLP)"},
	{0x0E, "Recommendation Q.922"},
	{0x0F, "Core aspects of Recommendation Q.922"},
	{0x10, "User specified"},
	{0x11, "ISO 7776 DTE-DTE operation"},
	{  -1, ""} };


struct vtsl LLC7[] = {
	{0x02, "Recommendation Q.931 (I.451)"},
	{0x06, "Recommendation X.25, packet layer"},
	{0x07, "ISO/IEC 8208 (X.25 packet level protocol for data terminal equipment)"},
	{0x08, "X.223 / ISO 8878 (use of ISO/IEC 8208 and Recommendation X.25 to provide the OSI-CONS)"},
	{0x09, "ISO/IEC 8473 (OSI connectionless mode protocol)"},
	{0x0A, "T.70 minimum network layer"},
	{0x0B, "ISO/IEC TR 9577 (Protocol identification in the network layer)"},
	{0x10, "User specified"},
	{  -1, ""} };


struct vtsl LLC7a[] = {
	{0x04, "Default packet size 16 octets"},
	{0x05, "Default packet size 32 octets"},
	{0x06, "Default packet size 64 octets"},
	{0x07, "Default packet size 128 octets"},
	{0x08, "Default packet size 256 octets"},
	{0x09, "Default packet size 512 octets"},
	{0x0A, "Default packet size 1024 octets"},
	{0x0B, "Default packet size 2048 octets"},
	{0x0C, "Default packet size 4096 octets"},
	{  -1, ""} };


char *dformatb[] = {
	"??? (00)",
	"5",
	"7",
	"8"
};


char *dformatp[] = {
	"O",
	"??? (01)",
	"E",
	"N",
	"S",
	"M",
	"??? (06)",
	"??? (07)"
};


char *dformats[] = {
	"??? (00)",
	"1",
	"1.5",
	"2"
};


struct vtsl HLCI[] = {
	{0x01, "Telephony"},
	{0x04, "Facsimile group 2/3 (F.182)"},
	{0x21, "Facsimile group 4, class I (F.184)"},
	{0x24, "Teletex service, basic and mixed mode (F.230) /\n\
		Fax service group 4, class II and III (F.184)"},
	{0x28, "Teletex service, basic and processable mode (F.220)"},
	{0x31, "Teletex service, basic mode (F.200)"},
	{0x32, "Syntax based Videotex (F.300/T.102)"},
	{0x33, "International videotex interworking via gateways\n\
				or IWUs (F.300/T.101)"},
	{0x35, "Telex service (F.60)"},
	{0x38, "Message handling systems (X.400)"},
	{0x41, "OSI applications (X.2xx)"},
	{0x42, "FTAM application (ETS 300 388)"},
	{0x5E, "Reserved for maintenance"},
	{0x5F, "Reserved for management"},
	{0x60, "Video telephony (F.720 / F.721)"},
	{0x61, "Video conferencing (F.730)"},
	{0x62, "Audiographic conferencing (F.710)"},
	{0x63, "(63) Reserved for audiovisual services (F.7xx)"},
	{0x64, "(64) Reserved for audiovisual services (F.7xx)"},
	{0x65, "(65) Reserved for audiovisual services (F.7xx)"},
	{0x66, "(66) Reserved for audiovisual services (F.7xx)"},
	{0x67, "(67) Reserved for audiovisual services (F.7xx)"},
	{0x68, "Multimedia services (F.700)"},
	{0x69, "(69) Reserved for audiovisual services (F.7xx)"},
	{0x6A, "(6A) Reserved for audiovisual services (F.7xx)"},
	{0x6B, "(6B) Reserved for audiovisual services (F.7xx)"},
	{0x6C, "(6C) Reserved for audiovisual services (F.7xx)"},
	{0x6D, "(6D) Reserved for audiovisual services (F.7xx)"},
	{0x6E, "(6E) Reserved for audiovisual services (F.7xx)"},
	{0x6F, "(6F) Reserved for audiovisual services (F.7xx)"},
	{0x7F, "<Reserved>"},
	{  -1, ""} };


char *facclass[] = {
	"Universal",
	"Application wide",
	"Context specific",
	"Private use"
};


struct vtsl notify[] = {
	{0x00, "User suspended"},
	{0x01, "User resumed"},
	{0x02, "Bearer service change"},
	{0x03, "ASN.1 encoded component"},
	{0x04, "Call completion delay"},

	{0x42, "conference established"},
	{0x43, "Conference disconnected"},
	{0x44, "Other party added"},
	{0x45, "Isolated"},
	{0x46, "Reattached"},
	{0x47, "Other party isolated"},
	{0x48, "Other party reattached"},
	{0x49, "Other party split"},
	{0x4A, "Other party disconnected"},
	{0x4B, "Cnference floating"},
	{0x4C, "Conference disconnected, preemption"},
	{0x4F, "Conference floating, served user preempted"},

	{0x60, "Call is a waiting call"},
	{0x68, "Diversion activated"},
	{0x69, "Call transferred alerting"},
	{0x6A, "Call transferred active"},
	{0x6E, "Reverse charging"},

	{0x79, "Remote hold"},
	{0x7A, "Remote retrieval"},
	{0x7B, "Call is diverting"},
	{  -1, ""} };


struct vtsl sgnl[] = {
	{0x00, "Dial tone on"},
	{0x01, "Ring back tone on"},
	{0x02, "Intercept tone on"},
	{0x03, "Network congestion tone on"},
	{0x04, "Busy tone on"},
	{0x05, "Confirm tone on"},
	{0x06, "Answer tone on"},	/* alerting */
	{0x07, "Call waiting tone on"},
	{0x08, "Off-hook warning tone on"},
	{0x09, "Preemption tone on"},
	{0x3F, "Tones off"},
	{0x40, "Alerting on - pattern 0"},
	{0x41, "Alerting on - pattern 1"},
	{0x42, "Alerting on - pattern 2"},
	{0x43, "Alerting on - pattern 3"},
	{0x44, "Alerting on - pattern 4"},
	{0x45, "Alerting on - pattern 5"},
	{0x46, "Alerting on - pattern 6"},
	{0x47, "Alerting on - pattern 7"},
	{0x4F, "Alerting off"},
	{  -1, ""} };


struct vtsl CState[] = {
	{0x00, "Null"},
	{0x01, "Call initiated"},
	{0x02, "Overlap sending"},
	{0x03, "Outgoing call proceeding"},
	{0x04, "Call delivered"},
	{0x06, "Call present"},
	{0x07, "Call received"},
	{0x08, "Connect request"},
	{0x09, "Incomming call proceeding"},
	{0x0A, "Active"},
	{0x0B, "Disconnect request"},
	{0x0C, "Disconnect indication"},
	{0x0F, "Suspend request"},
	{0x11, "Resume request"},
	{0x13, "Release request"},
	{0x16, "Call abort"},
	{0x19, "Overlap receiving"},
	{0x1A, "Modify request"},
	{0x1B, "Modify indication"},
	{0x1F, "Call indepentent service"},
	{0x3D, "Restart-request"},
	{0x3E, "Restart"},
	{  -1, ""} };


struct vtsl pdesc[] = {
	{0x01, "Call is not end-to-end ISDN"},
	{0x02, "Destination address is non-ISDN"},
	{0x03, "Originator address is non-ISDN"},
	{0x04, "Call has returned to the ISDN"},
	{0x05, "Service change due to interworking"},
	{0x08, "In-band information available now"},
	{0x0A, "Delay ub response at destination interface"},
	{0x10, "Interworking with public network"},/*???*/
	{0x20, "Pass along and SCCP available"},
	{0x40, "SCCP available"},
	{0x60, "Pass along available"},
	{  -1, ""} };


struct vtsl FeatStat[] = {
	{0x00, "Deactivated"},
	{0x01, "Acticated"},
	{0x02, "Prompt"},
	{0x03, "Pending"},
	{  -1, ""} };

struct vtsl Restart[] = {
	{0x00, "Indicated channels"},
	{0x06, "Single interface"},
	{0x07, "All interfaces"},
	{  -1, ""} };

#endif
