#include <stdio.h>
#include <string.h>
#include "global.h"
#include "globaltables.h"

#ifdef P_DSS1
#include "dss1.h"
#endif

#ifdef P_1TR6
#include "1tr6.h"
#endif

#ifdef P_ACKERMANN
#include "ackermann.h"
#endif

#ifdef P_AUERSWALD
#include "auerswald.h"
#endif

#ifdef U_CTI
#include "cti.h"
#endif


char	uk[11], indent[9], num[32],
	cgpn[40]="", cdpn[40]="", cgsa[40]="", cdsa[40]="", redi[40]="",
	P_INT[8]="00", P_NAT[8]="0", P_SUB[16]="", cgsatyp,
	logfile[1024]="",
	phonebook[1024]="/etc/isdn/phonebook",
	readfn[1024]="/dev/isdnctrl",
	execonconn[1024]="",
	execondisc[1024]="",
	logprefix[64]="",
	numconnects=0,
	*colour;
u_char	cause, si=-1, cgsi=-1, redr=-1;
struct  timeb rt1;
struct  tm rt2;

int	_L2=1, _Unk=1, broadcast=0, bcaddr=0, autoadd=0,
	_BC, NoData=0, NoData, CallRef[MaxCR];


char *coding[] = {
        "CCITT",
        "ISO/IEC",
        "National",
        "Network specific"
};


char *numtyp[] = {
        "Unknown",
        "International number",
        "National number",
        "Network specific number",
        "Subscriber number",
        "<undefined> (05)",
        "Abbreviated number",
        "<reserved> (07)"
};

struct vtsl redirtyp[] = {
        {0x00, "Unknown"},
        {0x01, "Call Forward Busy"},
        {0x02, "Call Forward No reply"},
        {0x04, "Call Deflection (4)"},  /* ??? */
        {0x09, "Called DTE out of order"},
        {0x0A, "Call Deflection"},
        {0x0F, "Call Forward Unconditional"},
        {0xFE, "(internally converted) Duplicate calling party number"},
        {  -1, ""} };


char *find(struct vtsl *list, int e) {
  int i;

  for(i=0; list[i].nr!=-1; i++)
    if (list[i].nr==e) break;

  if (list[i].nr==-1) {
    sprintf(uk, "??? (%.2X)", e);
    return(uk);
  } else
    return(list[i].descr);
}


void prnumber(u_char * p, char f_reason, char f_empty) {
  int l,t,t2=0;
  *num=0;

  p++;
  l = *p++ - 1;
  t=*p;
  if (!(t & 0x80)) t2=(*++p)&0x63;
////////////////////////////////////////
printf("%d\r",t2>>5);
////////////////////////////////////////
  if ((t2>>5)==0 || ((t>>4)&7)>0)
    printf("%sType of number		%s\n", indent, numtyp[(t>>4)&7]);
  if ((t2>>5)==0 || (t&15)>0)
    printf("%sNumbering plan		%s\n", indent, find(numplan, t&15));
  if (!(t & 0x80)) {
    printf("%sPresentation indicator	%s\n", indent, pilist[t2>>5]);
    if ((t2>>5)==0) printf("%sScreening indicator		%s\n", indent, silist[si=t2&3]);
      else si=-1;
    l--;
    if ((t2>>5)==1) strcpy(num,"!pr");
    if ((t2>>5)==2) strcpy(num,"!na");
  };
  if (!(*p & 0x80)) {
    if (f_reason==0) {
      printf("\x1b[41;37m\x1b[K!!%sOctet 3b (Reason for redirection) not allowed here !!%.8s\n", indent+2, colour);
    }
    t2=(*++p)&0x7f;
    printf("%sForwarding reason		%s\n", indent, find(redirtyp, t2&15));
    l--;
  };
  p++;
  if (l<0) l=0;
  if (l) {
    *num=0;
    switch(t>>4&7) {
      case 1:strcpy(num,P_INT);break;
      case 2:strcpy(num,P_NAT);break;
      case 4:strcpy(num,P_SUB);break;
    }
    t=-1;
    while (num[++t]);
    t2=t;
    while (l--)
      num[t++]=*p++;
    num[t]=0;
    printf("%sNumber			\"%s\"\n",indent,num+t2);
  } else {
    if (f_empty==0) {
      printf("\x1b[41;37m\x1b[K!!%sOctet(s) 4 missing (Maybe this IE should not exist?) !!%.8s\n", indent+2, colour);
    }
  }

}


void prchannel(u_char * p) {
  long int ch=0,n=0;
  int l;
  char t;

  p++;
  l = *p++;
  t=*p&0x7F;

  printf("    Interface type		");
  if (t&0x20)	printf("Other (PRI)");
  else		printf("BRI");
  if (t&0x40) {
    n=(*++p)&0x7F;
    while((*p&0x80)==0)
      n=n<<7|((*++p)&0x7F);
    printf("\n    Interface number		%ld",n);
  }
  printf("\n    Allocation priority		");
  if (t&0x08)	printf("Exclusive");
  else		printf("Preferred");
  printf("\n    Channel			");
  if (t&0x04)	printf("D-channel");
  else {
    if ((t&0x03)==0x00) printf("No channel");
    if ((t&0x23)==0x01) printf("B1-channel");
    if ((t&0x23)==0x02) printf("B2-channel");
    if ((t&0x23)==0x22) printf("??? (2)");
    if ((t&0x03)==0x03) printf("Any B-channel");
    if ((t&0x23)==0x03) printf(" (both B-channels)");
  }
  printf("\n");
  if ((t&0x23)==0x21) {
    p++;
    printf("      Coding			%s\n",coding[(*p>>5)&3]);
    printf("      Channel type		");
    switch (*p & 0x0F) {
      case 3 :printf("B-channel(s)");	break;
      case 6 :printf("H0-channel(s)");	break;
      case 8 :printf("H11-channel(s)");	break;
      case 9 :printf("H12-channel(s)");	break;
      default:printf("??? (%.2X)",*p&15);
    }
    printf("\n      Channel(s)		");
    if (*p & 0x10) {
      p++;
      l-=2;
      while (l--) {
	ch=(ch<<8)|*p++;
      }
      for(t=0; t<31; t++) {
	if (ch&(1<<t)) printf( "%d",t);
      }
    } else {
      printf("%d",*++p & 0x7F);
      while((*p&0x80)==0) {
        printf(" %d",*++p & 0x7F);
      }
    }
    printf("\n");
  }
}


void general(u_char * p) {
  int l, octet = 3;

  p++;
  l = *p++-1;

  /* Iterate over all octets in the information element */

  if (l>=0) {
    printf("    octet %d			%.2X ", octet, *p++);
    while (l--) {

      /* last octet in group? */
      if (*p & 0x80) {
        octet++;
        printf(" \n    octet %d			%.2X ", octet, *p++);
      } else
        printf("%.2X ", *p++);
    }
    printf("\n");
  } else
    printf("    octet %d			(empty)\n", octet);
}


void prdisplay(u_char * p) {
  int l;

  p++;
  l = *p++;
  printf("    Message			\"");
  while (l--) printf("%c",*p++);
  printf("\"\n");
}


void dlogsapi0 (u_char *buf, int size, int dir) {
  u_char *bend, res, ftyp;
  char	fttmp[16];

  ftyp = buf[2];

  if (_L2) {
    printf("%s", logprefix);
    if (ftyp&1) {
      printf(" %s", find(usftyp, ftyp));
      if ((ftyp & 2)==0) printf(" p/f=%d", buf[2]>>4&1);
    } else printf(" p/f=%d seqs=%d seqr=%d", buf[3]&1, buf[2]>>1, buf[3]>>1);
  } else if ((ftyp&3)!=1) {
    printf("%s", logprefix);
    if (ftyp&1) {
      strncpy(fttmp, find(usftyp, ftyp), sizeof(fttmp));
      res=0;
      while (fttmp[++res]>32);
      fttmp[res]=0;
      printf(" %s", fttmp);
    }
  }

  if ( ((ftyp&1)==0) | (ftyp==0x03) | (ftyp==0x13) ) {
    if ((ftyp & 3)==3) {
      buf += 3;
      size -= 3;
    } else {
      buf += 4;
      size -= 4;
    }
    bend = buf+size;
    res=0;

    switch(buf[0]) {
#ifdef P_DSS1
      case 0x08:	res=	dlogdss1(buf, bend, size);
				break;
#endif
#ifdef P_1TR6
      case 0x40:
      case 0x41:		dlog1tr6(buf, bend, size);
				break;
#endif
#ifdef P_AUERSWALD
      case 0x0d:		dlogAuerswald(buf, bend, size);
				break;
#endif
      case 0x44:
      case 0x47:		printf("%sAscom status %.2x\n", logprefix, buf[0]);
				break;
#ifdef P_ACKERMANN
      case 0xaa:		dlogAckermann(buf, bend, size);
				break;
#endif
      default:
	printf("\n%s\nUnknown protocol %.2x!\n", logprefix, buf[0]);
    }
#ifdef U_CTI
    if (res==5 && dir) showcall();
#endif
  } else if (((ftyp&3)!=1) | _L2) printf("\n");
}

void dlogsapi63(u_char *buf, int size, int dir) {
  if (buf[3]==15) {
      printf("%s TEI management ", logprefix);
      printf("\n  %s\t\tRN=%.2X%.2X, AI=%d\n", find(teiaction, buf[6]), buf[4], buf[5], buf[7]>>1);
  } else {
    printf("%s unknown management frame MEI=0x%.2X\n", logprefix, buf[3]);
  }
}

void dlogframe(u_char *buf, int size, int dir, char *time) {
  u_char sapi, tei, ftyp;
  char	temp[8];

  *cgpn=*cdpn=*cgsa=*cdsa=*redi=0;
  cgsi=-1;
  cgsatyp=-1;
  redr=0;

  sapi = buf[0] >> 2;
  tei  = buf[1] >> 1;
  ftyp = buf[2];

  if (dir) colour="\x1b[;32;1m";
      else colour="\x1b[;33;1m";
  snprintf(logprefix, sizeof(logprefix), "%s%c%s ", colour, dir?'>':'<' , time);
  if (_L2) {
    strcat(logprefix, frmtyp[ftyp & 3]);
    strcat(logprefix, " ");
  }
  if (tei==127) {
    strcat(logprefix, "broadcast");
  } else {
    sprintf(temp, "TEI %d", tei);
    strcat(logprefix, temp);
  }

  switch(sapi) {
    case  0:dlogsapi0(buf, size, dir);break;
    case 63:dlogsapi63(buf, size, dir);break;
    case  1:/* packet mode */
    case 16:/* X.25 level3 */
    default:
      if (tei == GROUP_TEI) {
        printf("%s unknown sapi %d, broadcast\n", logprefix, sapi);
      } else {
        printf("%s unknown sapi %d, tei %d\n", logprefix, sapi, tei);
      }
  }

}
