#include <netdb.h>
#include <arpa/inet.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <errno.h>
#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <stdlib.h>
#include "global.h"


int main(int argc, char **argv) {
  char sendbuf[1024], *name;
  char cgpn[32]="", cdpn[32]="", redi[32]="";
  char cgna[64]="", cdna[64]="", rena[64]="";
  int sock;
  struct sockaddr_in dest;
  struct hostent host;
  struct protoent proto;
  FILE *fi;
  unsigned int bcaddr=0xFF07A8C0;
  int broadcast=5148;

  ftime(&rt1);
  rt2=*localtime(&rt1.time);

  strncpy(cdpn,argv[1],32);
  if (argc>2) strncpy(cgpn,argv[2],32);
  if (argc>3) strncpy(cgna,argv[3],32);
  if (argc>4) strncpy(redi,argv[4],32);

  if ((fi=fopen(phonebook,"r"))) {
    while (!feof(fi)) {
      fgets(sendbuf, 1024, fi);
      sendbuf[strlen(sendbuf)-1]=0;
      name=sendbuf;
      while (*name++>32);
      *(name-1)=0;
      while (*name++<=32);
      name--;
      if (strcmp(sendbuf,cgpn)==0)	strncpy(cgna,name,64);
      if (strcmp(sendbuf,cdpn)==0)	strncpy(cdna,name,64);
      if (strcmp(sendbuf,redi)==0)	strncpy(rena,name,64);
      }
    fclose(fi);
    cgna[63]=0;
    cdna[63]=0;
    rena[63]=0;
  }

  sock=*cgna;

  if (sock==0) {
    if (*cgpn=='+') strcpy(num,cgpn+1); else strcpy(num,cgpn);
    fi=0;
    while (strlen(num)>0 && fi==0) {
      sprintf(sendbuf, "/etc/isdn/Locations/%s",num);
      fi=fopen(sendbuf, "r");
      num[strlen(num)-1]=0;
    }
    if (fi) {
      if (*cgpn=='+') strcpy(num,cgpn+1); else strcpy(num,cgpn);
      while (!feof(fi)) {
	fgets(sendbuf, 1024, fi);
	sendbuf[strlen(sendbuf)-1]=0;
	name=sendbuf;
	while (*name++>32);
	*(name-1)=0;
	while (*name++<=32);
	name--;
	if (*cgpn) if (strcmp(sendbuf,num)==0) strncpy(cgna,name,64);
      }
      fclose(fi);
    }
  }


  proto=*getprotobyname("udp");
  if ((sock=socket(PF_INET, SOCK_DGRAM, proto.p_proto))<0)
    fprintf(stderr, "Unable to create socket (%s)\n", strerror(errno));
  else {
    gethostname(sendbuf, 1024);
    host=*gethostbyname(sendbuf);
    errno=0;
    dest.sin_family=AF_INET;
    dest.sin_addr.s_addr=bcaddr;
    dest.sin_port=*host.h_addr_list[0];
    bind(sock, (struct sockaddr *) &dest, sizeof(dest));
    if (errno!=0) perror("sendto (bind)");

    errno=0;
    *sendbuf=-1;
    setsockopt(sock, SOL_SOCKET, SO_BROADCAST, sendbuf, sizeof(int));
    if (errno!=0) perror("sendto (setsockopt)");

    name=sendbuf;
		name+=sprintf(name, "%c%c%.2d:%.2d:%.2d", 0x06, 8,
					rt2.tm_hour, rt2.tm_min, rt2.tm_sec);
		name+=sprintf(name, "%c%c%c"  , 0x08, 1, _BC);
		name+=sprintf(name, "%c%c%s"  , 0x20, strlen(cgpn), cgpn);
    if (*cgna)  name+=sprintf(name, "%c%c%s"  , 0x22, strlen(cgna), cgna);
/*    if (*cgsa)  name+=sprintf(name, "%c%c%c%s", 0x28, strlen(cgsa)+1, cgsatyp, cgsa);	*/
		name+=sprintf(name, "%c%c%s"  , 0x40, strlen(cdpn), cdpn);
    if (*cdna)  name+=sprintf(name, "%c%c%s"  , 0x42, strlen(cdna), cdna);
/*    if (*cdsa)  name+=sprintf(name, "%c%c%s"  , 0x48, strlen(cdsa), cdsa);	*/
    if (*redi)  name+=sprintf(name, "%c%c%s"  , 0x30, strlen(redi), redi);
    if (*rena)  name+=sprintf(name, "%c%c%s"  , 0x32, strlen(rena), rena);
    name+=sprintf(name, "%c%c", 0, 0);
    dest.sin_family=AF_INET;
    dest.sin_addr.s_addr=bcaddr;
    dest.sin_port=htons(broadcast);

    errno=0;
    sendto(sock, sendbuf, name-sendbuf, 0, (struct sockaddr *) &dest, sizeof(dest));
    if (errno!=0) perror("sendto (sendto)");
    close(sock);
  }
  return(0);
}
